package com.loganmagnan.hubcore.commands;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.utils.ColorUtils;
import com.loganmagnan.hubcore.utils.CustomLocation;
import com.loganmagnan.hubcore.utils.command.BaseCommand;
import com.loganmagnan.hubcore.utils.command.Command;
import com.loganmagnan.hubcore.utils.command.CommandArguments;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;

public class SetSpawnCommand extends BaseCommand {

    private HubCore main = HubCore.getInstance();

    @Command(name = "setspawn", permission = "hubcore.command.setspawn")
    @Override
    public void executeAs(CommandArguments command) {
        Player player = command.getPlayer();

        String[] args = command.getArgs();

        if (args.length == 0) {
            this.main.getSpawnManager().setSpawnLocation(CustomLocation.fromBukkitLocation(player.getLocation()));

            this.saveLocation(player, "SPAWN.LOCATION");

            player.sendMessage(ColorUtils.getMessageType("&aSet the spawn location"));
        }
    }

    public void saveLocation(Player player, String location) {
        FileConfiguration config = this.main.getMainConfig().getConfig();
        config.set(location, CustomLocation.locationToString(CustomLocation.fromBukkitLocation(player.getLocation())));

        this.main.getMainConfig().save();
    }
}
