package com.loganmagnan.hubcore.listeners;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.managers.item.HotBarItem;
import com.loganmagnan.hubcore.menus.CosmeticsSelectorMenu;
import com.loganmagnan.hubcore.menus.ServerSelectorMenu;
import com.loganmagnan.hubcore.menus.SettingsSelectorMenu;
import com.loganmagnan.hubcore.playerdata.PlayerData;
import org.bukkit.GameMode;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;

public class PlayerInteractListener implements Listener {

    private HubCore main = HubCore.getInstance();

    @EventHandler
    public void onPlayerInteractOne(PlayerInteractEvent event) {
        Player player = event.getPlayer();

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        if (player.getGameMode() == GameMode.CREATIVE) {
            return;
        }

        if (event.getAction() != Action.RIGHT_CLICK_AIR && event.getAction() != Action.RIGHT_CLICK_BLOCK) {
            return;
        }

        if (!event.hasItem()) {
            return;
        }

        HotBarItem hotBarItem = HotBarItem.getItemByItemStack(player.getItemInHand());

        if (hotBarItem == null) {
            return;
        }

        if (hotBarItem.getActionType() == null) {
            return;
        }

        switch (playerData.getPlayerState()) {
            case SPAWN:
                switch (hotBarItem.getActionType()) {
                    case OPEN_SERVER_SELECTOR:
                        new ServerSelectorMenu(this.main.getPlayerMenuUtil(player)).open(player);

                        break;
                    case OPEN_COSMETICS_SELECTOR:
                        new CosmeticsSelectorMenu(this.main.getPlayerMenuUtil(player)).open(player);

                        break;
                    case OPEN_SETTINGS_SELECTOR:
                        new SettingsSelectorMenu(this.main.getPlayerMenuUtil(player)).open(player);

                        break;
                }

                break;
        }
    }

    @EventHandler
    public void onPlayerInteractTwo(PlayerInteractEvent event) {
        Player player = event.getPlayer();

        if (event.hasItem() && (event.getAction() == Action.RIGHT_CLICK_AIR || event.getAction() == Action.RIGHT_CLICK_BLOCK) && event.getItem().getType().equals(Material.ENDER_PEARL)) {
            event.setCancelled(true);

            player.getInventory().setItem(this.main.getHotBarConfig().getConfig().getInt("SPAWN.ENDER-PEARL.SLOT"), new ItemStack(Material.ENDER_PEARL, 1));
            player.setVelocity(event.getPlayer().getLocation().getDirection().multiply(1.50));
            player.updateInventory();
        }
    }
}
