package com.loganmagnan.hubcore.managers;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.utils.ColorUtils;
import com.loganmagnan.hubcore.utils.CustomLocation;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class SpawnManager {

    private HubCore main = HubCore.getInstance();

    private FileConfiguration config = this.main.getMainConfig().getConfig();

    private CustomLocation spawnLocation;

    private List<Player> players = new ArrayList<Player>();

    public SpawnManager() {
        this.loadConfig();
    }

    public void loadConfig() {
        if (this.config.contains("SPAWN.LOCATION")) {
            try {
                this.spawnLocation = CustomLocation.stringToLocation(this.config.getString("SPAWN.LOCATION"));
            } catch (NullPointerException exception) {
                Bukkit.getConsoleSender().sendMessage(ColorUtils.getMessageType("&cSpawn location not found"));
            }
        }
    }

    public void saveConfig() {
        this.config.set("SPAWN.LOCATION", CustomLocation.locationToString(this.spawnLocation));

        this.main.getMainConfig().save();
    }
}
