package com.loganmagnan.hubcore.managers.cosmetic;

import com.loganmagnan.hubcore.managers.item.ActionType;
import com.loganmagnan.hubcore.managers.item.HotBarItem;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.Effect;
import org.bukkit.inventory.ItemStack;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class Cosmetic {

    private ItemStack itemStack;
    private boolean enabled;
    private CosmeticType cosmeticType;
    private Effect effect;

    private static List<Cosmetic> items = new ArrayList<Cosmetic>();

    public Cosmetic(ItemStack itemStack, boolean enabled, String cosmeticType, String effect) {
        this.itemStack = itemStack;
        this.enabled = enabled;
        this.cosmeticType = CosmeticType.valueOf(cosmeticType);
        this.effect = Effect.valueOf(effect);

        items.add(this);
    }

    public static Cosmetic getItemByItemStack(ItemStack itemStack) {
        return items.stream().filter(item -> item.getItemStack().isSimilar(itemStack)).findFirst().orElse(null);
    }
}
