package com.loganmagnan.hubcore.managers.item;

import lombok.Getter;
import lombok.Setter;
import org.bukkit.inventory.ItemStack;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class HotBarItem {

    private ItemStack itemStack;
    private int slot;
    private boolean enabled;
    private ActionType actionType;

    private static List<HotBarItem> items = new ArrayList<HotBarItem>();

    public HotBarItem(ItemStack itemStack, int slot, boolean enabled, String actionType) {
        this.itemStack = itemStack;
        this.slot = slot;
        this.enabled = enabled;
        this.actionType = ActionType.valueOf(actionType);

        items.add(this);
    }

    public static HotBarItem getItemByItemStack(ItemStack itemStack) {
        return items.stream().filter(item -> item.getItemStack().isSimilar(itemStack)).findFirst().orElse(null);
    }
}
