package com.loganmagnan.hubcore.managers.item;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.utils.ColorUtils;
import com.loganmagnan.hubcore.utils.ItemUtil;
import com.loganmagnan.hubcore.utils.config.ConfigCursor;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.Material;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class HotBarManager {

    private HubCore main = HubCore.getInstance();

    private ConfigCursor configCursor;

    private List<HotBarItem> spawnItems = new ArrayList<HotBarItem>();

    public HotBarManager() {
        try {
            this.configCursor = new ConfigCursor(this.main.getHotBarConfig(), "SPAWN");

            for (String hubItem : this.main.getHotBarConfig().getConfig().getConfigurationSection("SPAWN").getKeys(false)) {
                this.spawnItems.add(new HotBarItem(ItemUtil.createUnbreakableItem(
                        Material.valueOf(this.configCursor.getString(hubItem + ".MATERIAL")),
                        ColorUtils.getMessageType(this.configCursor.getString(hubItem + ".NAME")),
                        this.configCursor.getInt(hubItem + ".AMOUNT"),
                        (short) this.configCursor.getInt(hubItem + ".DATA"),
                        this.configCursor.getInt(hubItem + ".CUSTOM-MODEL-DATA")),
                        this.configCursor.getInt(hubItem + ".SLOT"),
                        this.configCursor.getBoolean(hubItem + ".ENABLED"),
                        this.configCursor.getString(hubItem + ".ACTION-TYPE"))
                );
            }
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }
}
