package com.loganmagnan.hubcore.menus;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.utils.BungeeUtils;
import com.loganmagnan.hubcore.menusystem.Menu;
import com.loganmagnan.hubcore.menusystem.PlayerMenuUtil;
import com.loganmagnan.hubcore.utils.ColorUtils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class ServerSelectorMenu extends Menu {

    private HubCore main = HubCore.getInstance();

    public ServerSelectorMenu(PlayerMenuUtil playerMenuUtil) {
        super(playerMenuUtil);
    }

    @Override
    public String getMenuName() {
        return ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.SERVER-SELECTOR.TITLE"));
    }

    @Override
    public int getSlots() {
        return this.main.getMenusConfig().getConfig().getInt("MENUS.SERVER-SELECTOR.SIZE");
    }

    @Override
    public void handleMenu(InventoryClickEvent event) {
        Player player = (Player) event.getWhoClicked();

        if (event.getView().getTitle().equalsIgnoreCase(ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.SERVER-SELECTOR.TITLE")))) {
            ItemStack itemStack = new ItemStack(event.getCurrentItem().getType());

            ItemMeta itemMeta = itemStack.getItemMeta();
            itemMeta.setDisplayName(event.getCurrentItem().getItemMeta().getDisplayName());
            itemMeta.setLore(event.getCurrentItem().getItemMeta().getLore());

            itemStack.setItemMeta(itemMeta);

            if (event.getCurrentItem().equals(itemStack)) {
                for (int i = 0; i < this.main.getMenusConfig().getConfig().getConfigurationSection("MENUS.SERVER-SELECTOR.ITEMS").getKeys(false).size(); i++) {
                    ItemStack itemStackInFile = new ItemStack(Objects.requireNonNull(Material.getMaterial(Objects.requireNonNull(this.main.getMenusConfig().getConfig().getString("MENUS.SERVER-SELECTOR.ITEMS." + i + ".MATERIAL")))));
                    ItemMeta itemMetaInFile = itemStackInFile.getItemMeta();
                    itemMetaInFile.setDisplayName(ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.SERVER-SELECTOR.ITEMS." + i + ".NAME")));

                    List<String> lore = new ArrayList<String>();

                    for (String string : this.main.getMenusConfig().getConfig().getStringList("MENUS.SERVER-SELECTOR.ITEMS." + i + ".LORE")) {
                        lore.add(ColorUtils.getMessageType(string));
                    }

                    itemMetaInFile.setLore(lore);

                    itemStackInFile.setItemMeta(itemMetaInFile);

                    if (itemStack.equals(itemStackInFile)) {
                        BungeeUtils.sendPlayerToServer(player, this.main.getMenusConfig().getConfig().getString("MENUS.SERVER-SELECTOR.ITEMS." + i + ".SERVER"));

                        break;
                    }
                }
            }
        }
    }

    @Override
    public void setMenuItems(Player player) {
        this.setFillerGlass();

        for (int i = 0; i < this.main.getMenusConfig().getConfig().getConfigurationSection("MENUS.SERVER-SELECTOR.ITEMS").getKeys(false).size(); i++) {
            ItemStack itemStack = new ItemStack(Objects.requireNonNull(Material.getMaterial(Objects.requireNonNull(this.main.getMenusConfig().getConfig().getString("MENUS.SERVER-SELECTOR.ITEMS." + i + ".MATERIAL")))));

            ItemMeta itemMeta = itemStack.getItemMeta();
            itemMeta.setDisplayName(ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.SERVER-SELECTOR.ITEMS." + i + ".NAME")));

            List<String> lore = new ArrayList<String>();

            for (String string : this.main.getMenusConfig().getConfig().getStringList("MENUS.SERVER-SELECTOR.ITEMS." + i + ".LORE")) {
                lore.add(ColorUtils.getMessageType(string));
            }

            itemMeta.setLore(lore);

            itemStack.setItemMeta(itemMeta);

            this.inventory.setItem(this.main.getMenusConfig().getConfig().getInt("MENUS.SERVER-SELECTOR.ITEMS." + i + ".SLOT"), itemStack);
        }
    }
}
